import { Injectable, TemplateRef } from '@angular/core';
import { Router, NavigationEnd } from '@angular/router';
import { PopoverEntry } from '../classes/popover-entry.class';

@Injectable()
export class GistPopoverService {
    private popovers: { [ s: number ]: PopoverEntry } = {};
    public getPopoverList(): PopoverEntry[] {
        let me = this;
        let ret: PopoverEntry[] = [];
        for ( let pop in me.popovers ) {
            if ( me.popovers.hasOwnProperty( pop ) ) {
                ret.push( me.popovers[ pop ] );
            }
        }
        return ret;
    }
    public registerPopover( templateRef: TemplateRef<any> ): PopoverEntry {
        let ret = new PopoverEntry( templateRef );
        this.popovers[ ret.id ] = ret;
        return ret;
    }

    public unRegisterPopover( entry: PopoverEntry ): void {
        entry.destroy();
        delete this.popovers[ entry.id ];
    }
}

